//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "SPD.h"
#include "About.h"
#include "HasloFTP.h"
//---------------------------------------------------------------------
#pragma link "cspin"
#pragma link "IdBaseComponent"
#pragma link "IdComponent"
#pragma link "IdTrivialFTP"
#pragma link "IdUDPBase"
#pragma link "IdUDPClient"
#pragma link "IdExplicitTLSClientServerBase"
#pragma link "IdFTP"
#pragma link "IdTCPClient"
#pragma link "IdTCPConnection"
#pragma link "IBDatabase"
#pragma link "IBCustomDataSet"
#pragma link "IBQuery"
#pragma link "IdIOHandler"
#pragma link "IdIOHandlerSocket"
#pragma link "IdIOHandlerStack"
#pragma link "IdSSL"
#pragma link "IdSSLOpenSSL"
#pragma link "IdIntercept"

#pragma resource "*.dfm"
//---------------------------------------------------------------------
CSPDUstawienie::CSPDUstawienie(UnicodeString _sParam,UnicodeString _sWartosc,TWinControl *_ctrObject)
{
	sParam = _sParam;
	sWartosc = _sWartosc;
	ctrObject = _ctrObject;
}
//---------------------------------------------------------------------
CSPDUstawienie::~CSPDUstawienie()
{
}
//---------------------------------------------------------------------
//---------------------------------------------------------------------
//- FORMATKA SPD - SYSTEM PRZESYANIA DANYCH
//---------------------------------------------------------------------
//---------------------------------------------------------------------
TfrmSPD *frmSPD;
//---------------------------------------------------------------------
__fastcall TfrmSPD::TfrmSPD(TComponent *AOwner)
	: TForm(AOwner)
{
	this->vInicjacja();
	this->vPrzygotujOkno();
	this->sKodSystemu = "EF";
	pgSPD->ActivePage = tbsFK;
	pnlZatwierdz->Visible = true;
}
//---------------------------------------------------------------------
void TfrmSPD::vInicjacja()
{
	objWyk = new CWykonawca();
	// USTAWIENIE ZMIENNYCH
	this->sKatalog = GetCurrentDir();
	this->sPlikUstawienia = this->sKatalog + "\\config_spd.ini";
	this->vWczytajUstawienia();
	Screen->OnActiveControlChange = objWyk->ControlChange;
	sCaption = "EtoSPD - System przesyania danych stray poarnej. Version[1.0.1.15]";
	this->Caption = sCaption;
	// PRZYGOTOWANIE USTAWIEN
//	edtGenWyd->Text = "1300,1302,1303,1304,1306,1307,1308,1309,";
//	edtGenDoch->Text = "1301,132,";
//	edtGenPlan->Text = "980,";
//	edtGenZan->Text = "998,";
//	edtGenOper->Text ="Tomasz Grygoruk";
//	edtGenCzesc->Text = "85";
}
//---------------------------------------------------------------------
void TfrmSPD::vDeInicjacja()
{
}
//---------------------------------------------------------------------
void TfrmSPD::vPrzygotujOkno()
{
	// USTAWIENIE DRZEWKA I PAGE CONTROL
	bool bTabVisible = false;
	for( int i=0;i<pgSPD->PageCount; i++ ) pgSPD->Pages[i]->TabVisible = bTabVisible;
	treeSPD->Items->Clear();
	TTreeNode *tnd = treeSPD->Items->AddFirst(NULL , "Start");
	tnd->SelectedIndex = 0;
	tnd = treeSPD->Items->Add(tnd , "Fin-ksig");
	tnd->SelectedIndex = 1;
	tnd = treeSPD->Items->Add(tnd , "Pace");
	tnd->SelectedIndex = 2;
	tnd = treeSPD->Items->Add(tnd , "Archiwum");
	tnd->SelectedIndex = 3;
	tnd = treeSPD->Items->Add(tnd , "Ustawienia");
	tnd->SelectedIndex = 4;
	for( int i=0; i <treeSPD->Items->Count; i++ )
	{
		TTreeNode *nd = treeSPD->Items->Item[i];
		if( nd->SelectedIndex == 0 ) treeSPD->Selected = nd;
	}
	pgSPD->ActivePageIndex = 0;
	// PRZYGOTOWANIE PANELI NA STATUS BAR
	stbSPD->Panels->Items[0]->Width = 150;
	stbSPD->Panels->Items[1]->Text = this->sKatalog;
	stbSPD->Panels->Items[2]->Text = Date().FormatString("YYYY-MM-DD");
	for( int i=1; i< stbSPD->Panels->Count; i++ )
	{
		int x = stbSPD->Canvas->TextWidth( stbSPD->Panels->Items[i]->Text ) + 25;
		stbSPD->Panels->Items[i]->Width = x;
	}
	// UKRYCIE PASKA PRZYCISKOW
	pnlZatwierdz->Visible = false;
	btnZatwierdz->Enabled = false;
	dtpFK->Date = Date();
	lblFK->Caption = "";
	try
	{
		int iIndex = Date().FormatString("MM").ToInt() - 1;
		if( iIndex > 0 )
		{
			cmbOkresFK->ItemIndex = iIndex;
      	chbPBD->Checked = true;
			chbSTK->Checked = true;
		}
	}
	catch(Exception &e)
	{
	}
}
//---------------------------------------------------------------------
bool TfrmSPD::bSprawdzFormatke()
{
	bool bWynik = true;
	UnicodeString sKomunikat="";
	TTabSheet *tabBlad = NULL;
	TWinControl *objBlad = NULL;
	int iLicznik = 0;
	// CZESC FK
	if( edtFK->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". cieka katalogu FK nie moe pusta.\n";
		tabBlad = tbsFK;
		objBlad = edtFK;
	}
	if( edtArchFK->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". cieka archiwizacji FK nie moe pusta.\n";
		tabBlad = tbsFK;
		objBlad = edtArchFK;
	}
	// CZESC PLACE
	if( edtPlace->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". cieka katalogu kadry i pace nie moe pusta.\n";
		tabBlad = tbsPlace;
		objBlad = edtPlace;
	}
	if( edtPlaceArch->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". cieka archiwizacji kadry i pace nie moe pusta.\n";
		tabBlad = tbsPlace;
		objBlad = edtPlaceArch;
	}
	// CZESC OGOLNA
	// MOZNA NIE WPROWADZA NAZWY UZYTKOWNIKA I HASLA ORAZ SERWERA FTP I CIEZKI PLIKU FTP
	if( edtHaslo1->Text.Length() > 0  || edtHaslo2->Text.Length()>0 )
	{
		if( edtUzytkownik->Text.Length()==0 )
		{
			sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Nazwa uytkownika nie moe pusta.\n";
			tabBlad = tbsUstawienia;
			objBlad = edtUzytkownik;
		}
		else if( edtHaslo1->Text != edtHaslo2->Text )
		{
			sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Wprowadzone hasa si nie zgadzaj lub jedno z nich jest puste.\n";
			tabBlad = tbsUstawienia;
			objBlad = edtHaslo1;
		}
	}
	if( edtPort->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Numer portu nie moe pusty.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtPort;
	}
	else
	{
		try
		{
			edtPort->Text.ToInt();
		}
		catch( Exception &e)
		{
			sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Numer portu ma nie prawidowy format.\n";
			tabBlad = tbsUstawienia;
			objBlad = edtPort;
		}
	}
	if( cmbWoj->ItemIndex == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Kod wojewdztwa nie zosta wybrany.\n";
		tabBlad = tbsUstawienia;
		objBlad = cmbWoj;
	}
	if( edtNumerJedn->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Numer jednostki nie moe pusty.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtPort;
	}
	if( edtRok->Text.Length() == 0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Rok nie moe pusty.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtRok;
	}
	// WYDATKI
	if( edtGenWyd->Text.Length()==0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Konto wydatkw nie moe puste.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtRok;
	}
	else if( edtGenWyd->Text[ edtGenWyd->Text.Length() ] != ',' ) edtGenWyd->Text = edtGenWyd->Text+",";
	// DOCHODY
	if( edtGenDoch->Text.Length()==0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Konto dochodw nie moe puste.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtRok;
	}
	else if( edtGenDoch->Text[ edtGenDoch->Text.Length() ] != ',' ) edtGenDoch->Text = edtGenDoch->Text+",";
	// PLAN
	if( edtGenPlan->Text.Length()==0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Konto planu nie moe puste.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtRok;
	}
	else if( edtGenPlan->Text[ edtGenPlan->Text.Length() ] != ',' ) edtGenPlan->Text = edtGenPlan->Text+",";
	// WYDATKI
	if( edtGenZan->Text.Length()==0 )
	{
		sKomunikat = sKomunikat+(UnicodeString)(iLicznik++)+". Konto zaangaowania nie moe puste.\n";
		tabBlad = tbsUstawienia;
		objBlad = edtRok;
	}
	else if( edtGenZan->Text[ edtGenZan->Text.Length() ] != ',' ) edtGenZan->Text = edtGenZan->Text+",";
	//---------------------------------------------------------------------------
	// EWENTUALNE WYWOLANIE BLEDU
	//---------------------------------------------------------------------------
	if( tabBlad && objBlad )
	{
		pgSPD->ActivePage = tabBlad;
		objBlad->SetFocus();
		bWynik = false;
		MessageBox( this->WindowHandle, sKomunikat.t_str(), " Wystpiy bdy.",MB_OK | MB_ICONHAND | MB_APPLMODAL );
	}
	return bWynik;
}
//---------------------------------------------------------------------
void TfrmSPD::vZapiszUstawienia(bool bFormatka)
{

	if( bFormatka )
	{
		FILE *fw = fopen( this->sPlikUstawienia.t_str() , "w" );
		if( fw )
		{
			UnicodeString sLinia = "";
			sLinia = "sUSER^"+edtUzytkownik->Text+"^edtUzytkownik\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sHASLO^"+edtHaslo1->Text+"^edtHaslo1\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sSERVER_FTP^"+edtFTP->Text+"^edtFTP\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sSCIEZKA_FTP^"+edtSciezkaFTP->Text+"^edtSciezkaFTP\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iPORT_FTP^"+edtPort->Text+"^edtPort\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sWERSJA_SPD^"+edtWersjaSPD->Text+"^edtWersjaSPD\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sKOD_WOJ^"+cmbWoj->Text+"^cmbWoj\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sNUMER_JEDN^"+edtNumerJedn->Text+"^edtNumerJedn\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_DZIEN^"+edtDzienFK->Text+"^edtDzienFK\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sFK_KATALOG^"+edtFK->Text+"^edtFK\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sFK_ARCH^"+edtArchFK->Text+"^edtArchFK\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_KOD^"+(UnicodeString)cmbKodFK->ItemIndex+"^cmbKodFK\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sPLACE_KATALOG^"+edtPlace->Text+"^edtPlace\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sPLACE_ARCH^"+edtPlaceArch->Text+"^edtPlaceArch\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iPLACE_KOD^"+(UnicodeString)cmbKodPlace->ItemIndex+"^cmbKodPlace\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sROK^"+edtRok->Text+"^edtRok\n";
			fputs(sLinia.t_str(), fw );
			if( chbFTP->Checked )sLinia = "iWYSLIJFTP^1^chbFTP\n";
			else sLinia = "iWYSLIJFTP^0^chbFTP\n";
			fputs(sLinia.t_str(), fw );
			// DODANE 2010.10.19
			if( chbWindows->Checked ) sLinia = "iFK_WINDOWS^1^chbWindows\n";
			else sLinia = "iFK_WINDOWS^0^chbWindows\n";
			fputs(sLinia.t_str(), fw );
			if( chbDodNumer->Checked ) sLinia = "iFK_DOD_ZNAK^1^chbDodNumer\n";
			else sLinia = "iFK_DOD_ZNAK^0^chbDodNumer\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_WYD^"+edtGenWyd->Text+"^edtGenWyd\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_DOCH^"+edtGenDoch->Text+"^edtGenDoch\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_PLAN^"+edtGenPlan->Text+"^edtGenPlan\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "iFK_ZAN^"+edtGenZan->Text+"^edtGenZan\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sFK_CZESC^"+edtGenCzesc->Text+"^edtGenCzesc\n";
			fputs(sLinia.t_str(), fw );
			sLinia = "sFK_OPER^"+edtGenOper->Text+"^edtGenOper\n";
			fputs(sLinia.t_str(), fw );
			fclose( fw );
			this->vUstawZapisFTP( this->bFTP );
		}
	}
}
//---------------------------------------------------------------------
void TfrmSPD::vWczytajUstawienia()
{
/*
sUSER^^edtUzytkownik
sHASLO^^edtHaslo1
sSERVER_FTP^^edtFTP
sSCIEZKA_FTP^^edtSciezkaFTP
iPORT_FTP^21^edtPort
sWERSJA_SPD^10^edtWersjaSPD
sKOD_WOJ^B - podlaskie^cmbWoj
sNUMER_JEDN^1000000^edtNumerJedn
iFK_DZIEN^14^edtDzienFK
sFK_KATALOG^v:\tomek\fk10^edtFK
sFK_ARCH^d:\temp\spd\fkarch^edtArchFK
iFK_KOD^2^cmbKodFK
sPLACE_KATALOG^d:\temp\spd\place^edtPlace
sPLACE_ARCH^d:\temp\spd\placearch^edtPlaceArch
iPLACE_KOD^2^cmbKodPlace
sROK^2010^edtRok
iWYSLIJFTP^0^chbFTP

iFK_WINDOWS^0^chbWindows
iFK_DOD_ZNAK^1^chbDokNumer
iFK_WYD^1300^edtGenWyd
iFK_DOCH^1301^edtGenDoch
iFK_PLAN^998^edtGenPlan
iFK_ZAN^998^edtGenZan
sWINSCP3^C:\Program Files\Winscp3\Winscp3.com^edtWinSCP

*/
	// JEZELI ISTNIEJE PLIK TO CZYTAMY PLIK
	if( !FileExists( this->sPlikUstawienia ) )
	{
		FILE *fw = fopen( this->sPlikUstawienia.t_str() , "w" );
		if( fw )
		{
			fputs("sUSER^userSPD^edtUzytkownik\n",fw );
			fputs("sHASLO^^edtHaslo1\n",fw );
			fputs("sSERVER_FTP^^edtFTP\n",fw );
			fputs("sSCIEZKA_FTP^^edtSciezkaFTP\n",fw );
			fputs("iPORT_FTP^21^edtPort\n",fw );
			fputs("sWERSJA_SPD^10^edtWersjaSPD\n",fw );
			fputs("sKOD_WOJ^B - podlaskie^cmbWoj\n",fw );
			fputs("sNUMER_JEDN^1000000^edtNumerJedn\n",fw );
			fputs("iFK_DZIEN^14^edtDzienFK\n",fw );
			fputs("sFK_KATALOG^^edtFK\n",fw );
			fputs("sFK_ARCH^^edtArchFK\n",fw );
			fputs("iFK_KOD^2^cmbKodFK\n",fw );
			fputs("sPLACE_KATALOG^^edtPlace\n",fw );
			fputs("sPLACE_ARCH^^edtPlaceArch\n",fw );
			fputs("iPLACE_KOD^2^cmbKodPlace\n",fw );
			fputs("sROK^2010^edtRok\n",fw );
			fputs("iWYSLIJFTP^0^chbFTP\n",fw );
			// DODANE 2010.10.19
			fputs("iFK_WINDOWS^0^chbWindows\n",fw );
			fputs("iFK_DOD_ZNAK^1^chbDokNumer\n",fw );
			fputs("iFK_WYD^1300,^edtGenWyd\n",fw );
			fputs("iFK_DOCH^1301,^edtGenDoch\n",fw );
			fputs("iFK_PLAN^998,^edtGenPlan\n",fw );
			fputs("iFK_ZAN^998,^edtGenZan\n",fw );
			fputs("sFK_CZESC^85^edtGenCzesc\n",fw );
			fputs("sFK_OPERATOR^Tomasz Grygoruk^edtGenOper\n",fw);
			fputs("sWINSCP3^C:\Program Files\Winscp3\Winscp3.com^edtWinSCP",fw);
			fclose( fw );
		}
	}
	if( FileExists( this->sPlikUstawienia ) )
	{
		FILE *fr = fopen( this->sPlikUstawienia.t_str() , "r" );
		if( fr )
		{
			char cLinia[256];
			while( fgets( cLinia,256,fr) )
			{
				UnicodeString sLinia=(UnicodeString)cLinia;
				// POBIERAMY NAZWE PARAMETRU
				int iSeparator = sLinia.Pos( "^" );
				UnicodeString sParam = sLinia.SubString(1,iSeparator - 1 );
				sLinia = sLinia.SubString( iSeparator +1 , sLinia.Length()-iSeparator);
				// POBIERAMY WARTOSC
				iSeparator = sLinia.Pos( "^" );
				UnicodeString sWartosc = sLinia.SubString(1,iSeparator - 1 );
				sLinia = sLinia.SubString( iSeparator +1 , sLinia.Length()-iSeparator);
				// TERAZ W sLINIA ZNAJDUJE SI NAZWA FORMATKI i NALEZY USUNAC ZNAKI \n i \r
				UnicodeString sKontrolka="";
				for( int i=1;i<=sLinia.Length(); i++ )
				{
					char c = sLinia[i];
					if( c!='\n' && c!='\r' ) sKontrolka = sKontrolka + (UnicodeString)c;
				}
				if( sParam=="sUSER") edtUzytkownik->Text = sWartosc;
				if( sParam=="sHASLO")
				{
					edtHaslo1->Text = sWartosc;
					edtHaslo2->Text = sWartosc;
				}
				if( sParam=="sSERVER_FTP") edtFTP->Text = sWartosc;
				if( sParam=="sSCIEZKA_FTP") edtSciezkaFTP->Text = sWartosc;
				if( sParam=="iPORT_FTP") edtPort->Text = sWartosc;
				if( sParam=="sWERSJA_SPD")
				{
					edtWersjaSPD->Text = sWartosc;
					this->sWersjaSPD = sWartosc;
				}
				if( sParam=="sKOD_WOJ") cmbWoj->ItemIndex = cmbWoj->Items->IndexOf( sWartosc );
				if( sParam=="sNUMER_JEDN")
				{
					edtNumerJedn->Text = sWartosc;
					this->sNumerJednostki = sWartosc;
				}
				if( sParam=="iFK_DZIEN") edtDzienFK->Text = sWartosc;
				if( sParam=="sFK_KATALOG") edtFK->Text = sWartosc;
				if( sParam=="sFK_ARCH") edtArchFK->Text = sWartosc;
				if( sParam=="iFK_KOD")
				{
					cmbKodFK->ItemIndex = sWartosc.ToInt();
					this->iStandartFK = sWartosc.ToInt();
				}
				if( sParam=="sPLACE_KATALOG") edtPlace->Text = sWartosc;
				if( sParam=="sPLACE_ARCH") edtPlaceArch->Text = sWartosc;
				if( sParam=="iPLACE_KOD")
				{
					cmbKodPlace->ItemIndex = sWartosc.ToInt();
					this->iStandartPlace = sWartosc.ToInt();
				}
				if( sParam=="sROK") edtRok->Text = sWartosc;
				if( sParam=="iWYSLIJFTP")
				{
					if( sWartosc=="0" ) chbFTP->Checked = false;
					else chbFTP->Checked = true;
					bFTP = chbFTP->Checked;
					this->vUstawZapisFTP( bFTP );
				}
				if( sParam=="iFK_WINDOWS")
				{
					if( sWartosc=="0" ) chbWindows->Checked = false;
					else chbWindows->Checked = true;
				}
				if( sParam=="iFK_DOD_ZNAK")
				{
					if( sWartosc=="0" ) chbDodNumer->Checked = false;
					else chbDodNumer->Checked = true;
				}
				if( sParam=="iFK_WYD") edtGenWyd->Text = sWartosc;
				if( sParam=="iFK_DOCH") edtGenDoch->Text = sWartosc;
				if( sParam=="iFK_PLAN") edtGenPlan->Text = sWartosc;
				if( sParam=="iFK_ZAN") edtGenZan->Text = sWartosc;
				if( sParam=="sFK_CZESC") edtGenCzesc->Text = sWartosc;
				if( sParam=="sFK_OPER") edtGenOper->Text = sWartosc;
			}
			fclose( fr );
		}
	}
}
//---------------------------------------------------------------------
TWinControl* TfrmSPD::ctrZnajdz(TWinControl *parent,UnicodeString sNazwa)
{
	TWinControl *ctr = NULL;
	for( int i=0;i<parent->ControlCount;i++ )
	{
		if( parent->Controls[i]->Name==sNazwa )
		{
			ctr = (TWinControl*)parent->Controls[i];
			break;
		}
	}
	return ctr;
}
//---------------------------------------------------------------------
UnicodeString TfrmSPD::sUtworzNazwePliku(bool bWysylka,UnicodeString sObszar,UnicodeString sKodSystDziedz,TDateTime tCzas,UnicodeString sEncja,int iOkres)
{
	UnicodeString sNazwa;
	TDateTime t = Date();
	if( (int)tCzas>0 ) t = tCzas;
	if( bWysylka )
	{
		sNazwa = this->sNumerJednostki+sObszar+sWersjaSPD+sKodSystDziedz+t.FormatString("YYYYMMDD");
		sNazwa = sNazwa+Time().FormatString("hhnnss")+"000000";
	}
	else
	{
		if( sObszar=="F" )
		{
			TDateTime tDataBiznes = t;
			if( sEncja=="STK") tDataBiznes = TDateTime( edtRok->Text.ToInt(),iOkres,1);
			if( sEncja=="PBD") tDataBiznes = TDateTime( edtRok->Text.ToInt(),1,1);
			sNazwa = sKodSystDziedz+sEncja+tDataBiznes.FormatString("YYYY-MM-DD");
		}
	}
	return sNazwa;
}
//---------------------------------------------------------------------
void TfrmSPD::vWyslijFK(int iOkres,TDateTime tCzas,bool bPBD,bool bSTK)
{
	UnicodeString sMessage="";
	if( objFTP->Connected() ) objFTP->Disconnect();
	if( this->Visible )
	{
		SetCurrentDir( this->sKatalog );
// 1. UTWORZENIE ODPOWIEDNIEJ NAZWY PLIKUS
		UnicodeString sPlik="";
		UnicodeString sWysylka = this->sUtworzNazwePliku(true,"F",this->sKodSystemu,tCzas,"",iOkres);
		UnicodeString sSTK = this->sUtworzNazwePliku(false,"F",this->sKodSystemu,tCzas,"STK",iOkres);
		UnicodeString sPBD = this->sUtworzNazwePliku(false,"F",this->sKodSystemu,tCzas,"PBD",iOkres);
		pgbFK->Max = 7;
		pgbFK->Position = 0;
// 2. UTWORZENIE PLIKU *.CSV i KATALOGU DO WYSLKI
		if( CreateDir( sKatalog + "\\"+sWysylka ) )
		{
			pgbFK->Position = 1;
			lblFK->Caption = "Tworzenie pliku "+sWysylka+".csv.";
			pnlWyslijFK->Repaint();
Sleep(  100 );
			int iRekord = 0;
			if( bPBD ) iRekord += this->iGenerujPlikFK(sWysylka,sPBD,iOkres,"PBD");
			if( bSTK ) iRekord += this->iGenerujPlikFK(sWysylka,sSTK,iOkres,"STK");
			if( iRekord > 0 )
			{
	// 3. PAKOWANIE PLIKU do ZIP i PODPISANIE MD5
				pgbFK->Position = 2;
				pgbFK->Max = 7;
				lblFK->Caption = "Tworzenie pliku archiwum "+sWysylka+".zip. Podpisywanie algorytmem MD5";
				pnlWyslijFK->Repaint();
				// TWORZENIE PLIKU ARCHIWUM DO WYSYLKI i ARCHIWUM DO PRZEKAZANIA
//				UnicodeString sZip = "7z a -tzip "+sWysylka+".zip "+this->sKatalog+"\\"+sWysylka;
				UnicodeString sZip = "7z a -tzip "+sWysylka+".zip "+sWysylka;
				system( sZip.t_str() );
				if( FileExists(this->sKatalog+"\\"+sWysylka+".zip") )
				{
					// PODPISYWANIE PLIKU i TWORZENIE MD5
					UnicodeString sDoPodpisu =  this->sKatalog+"\\"+sWysylka+".zip";
					UnicodeString sMD5 = MD5File( sDoPodpisu.t_str() );
					sPlik = this->sKatalog + "\\"+sWysylka+".md5";
					FILE *fMD5 = fopen( sPlik.t_str(),"w");
					if( fMD5 )
					{
						fputs( sMD5.t_str(), fMD5 );
						fclose( fMD5 );
						// USUNIECIE PLIKU CSV
						if( bPBD ) DeleteFile( this->sKatalog+"\\"+sWysylka+"\\"+sPBD+".csv" );
						if( bSTK ) DeleteFile( this->sKatalog+"\\"+sWysylka+"\\"+sSTK+".csv" );
						RemoveDir( this->sKatalog+"\\"+sWysylka );
						Sleep(  100 );
// 4. UTWORZENIE PLIKU SEMAFORA
						pgbFK->Position = 3;
						lblFK->Caption = "Tworzenie pliku semafora "+sWysylka+"CSV.";
						pnlWyslijFK->Repaint();
						sPlik = this->sKatalog + "\\"+sWysylka+".sem";
						FILE *fSEM = fopen( sPlik.t_str(),"w");
						if( fSEM )
						{
							fclose(fSEM);
							Sleep(  100 );
// 5. PROBA WYSYLKI NA FTP
							pgbFK->Position = 4;
							lblFK->Caption = "Wysyanie zestawu plikw "+sWysylka+".";
							Sleep(  100 );
							if( bFTP )
							{
								UnicodeString sPlikSSH = this->sKatalog+"\\ssh.txt";
								if( FileExists(this->sKatalog+"\\WinSCP3.com") && FileExists(this->sKatalog+"\\WinSCP3.exe") )
								{
									bool bSSH = false;
									// TWORZYMY SKRYPT SSH
									if( FileExists(sPlikSSH) ) DeleteFile(sPlikSSH);
									FILE *fw = fopen( sPlikSSH.t_str(),"w");
									if( fw )
									{
										UnicodeString sLinia = "open sftp://"+edtUzytkownik->Text+":"+edtHaslo1->Text+"@"+
																		edtFTP->Text+":"+edtPort->Text+"\n";
										fputs(sLinia.t_str(), fw );
										sLinia = "CD "+edtSciezkaFTP->Text+"\n";
										fputs(sLinia.t_str(), fw );
										sLinia = "put "+sWysylka+".zip \n";
										fputs(sLinia.t_str(), fw );
										sLinia = "put "+sWysylka+".md5 \n";
										fputs(sLinia.t_str(), fw );
										sLinia = "put "+sWysylka+".sem \n";
										fputs(sLinia.t_str(), fw );
										sLinia = "ls "+sWysylka+".*\n";
										fputs(sLinia.t_str(), fw );
//										fputs("close\n", fw );
//										fputs("exit\n", fw );
										fclose(fw);
									}
									if( FileExists(this->sKatalog+"\\ssh.txt" ) ) bSSH = true;
									// URUCHAMIAMY POLECENIE
									if( bSSH )
									{
										AnsiString sW = "Winscp3.com /script=\""+this->sKatalog+"\\ssh.txt\"";
										system( sW.c_str() );
										pgbFK->Position = 5;
										lblFK->Caption = "Przeniesienie do archiwum "+sWysylka+".";
										pnlWyslijFK->Repaint();
										Sleep(  100 );
										pgbFK->Position = 6;
										Sleep(  100 );
										pgbFK->Position = 7;
										Sleep(  100 );

										UnicodeString sWiad = "Pomylnie zakoczono wysyanie danych o identyfikatorze "+sWysylka+".";
										MessageBox( Application->Handle,sWiad.t_str(),"Sukces.",MB_OK | MB_ICONEXCLAMATION | MB_APPLMODAL );
										SetCurrentDir( this->sKatalog );

									}
								}
								else "Nie mona nawiza poczenia z programem WinSCP3.(brak pliku WinSCP3.com lub WinSCP3.exe";
							}
							else
							{
								UnicodeString sTekst = "Wygenerowano zestaw plikw w "+sKatalog +" o nazwie "+sWysylka;
								MessageBox( Application->Handle , sTekst.t_str() , "Sukces.", MB_OK | MB_APPLMODAL );
								Sleep(  100 );
								pgbFK->Position = 7;
							}
						}
						else sMessage = "Nie powioda si prba utworzenia pliku "+sWysylka+".sem.";
					}
					else sMessage = "Nie powioda si prba utworzenia pliku "+sWysylka+".md5.";
				}
				else sMessage = "Nie powioda si prba utworzenia pliku "+sWysylka+".zip.";
			}
			else sMessage = "Nie udao si utworzy plikw importu o identyfikatorze ["+sWysylka+"].";
		}
		else sMessage = "Nie udao si utworzy katalogu do wysyki.";
		if( sMessage.Length()>0 )
		{
			lblFK->Caption = "";
			pgbFK->Position = 0;
			pnlWyslijFK->Repaint();
			MessageBox( Application->Handle,sMessage.t_str(),"Bd SPD.", MB_OK | MB_ICONHAND | MB_APPLMODAL );
		}
	}
}
//---------------------------------------------------------------------
int  TfrmSPD::iGenerujPlikFK(UnicodeString sDir,UnicodeString sPlikNazwa,int iOkres,UnicodeString sEncja)
{
	TQuery *tblKSO = new TQuery(this);
	TQuery *tblKPK = new TQuery(this);
	int iRekord=1;
	// UTWORZENIE PLIKU
	try
	{

		UnicodeString sPlik = this->sKatalog +"\\"+sDir+"\\"+sPlikNazwa+".csv";
		FILE *fCSV = fopen( sPlik.t_str(),"w");
		if( fCSV )
		{
			// USTALANIE NAGLOWKA FINANSE KSIEGOWOSC
			UnicodeString sNaglowek =  "NUMER KONTA|NAZWA KONTA|CZʌ BUDETU|DZIA BUDETU|ROZDZIA BUDETU|NUMER PARAGRAFU|";
			sNaglowek = sNaglowek + "ANALITYKA PARAGRAFU|RDO FINANSOWANIA|OBROTY WN|OBROTY MA|SALDO WN|SALDO MA|";
			if( sEncja=="PBD" ) sNaglowek = sNaglowek +"KWOTA PLANU BUDETU|ROK BUDETOWY\n";
			if( sEncja=="STK" ) sNaglowek = sNaglowek +"SALDO KONTA|ROK BUDETOWY|OKRES ROZLICZENIOWY\n";
			fputs( sNaglowek.t_str(), fCSV );
			// OTWARCIE TABELI DANCH DLA SYSTEMU DOS
			if( chbWindows->Checked  )
			{
				dbBaza->Connected = true;
				if( tsnBaza->Active ) tsnBaza->Active = false;
				tsnBaza->StartTransaction();
				queND->Close();
				queND->ParamCheck = true;
				queND->SQL->Clear();
				queND->SQL->Add("select * from FK_PREZENTACJA_SPD( :OKRES,1,-1 ) A");
				queND->SQL->Add("order by a.KONTO");
				queND->ParamByName("OKRES")->AsInteger = cmbOkresFK->ItemIndex;
/*          // POPRZEDNI STAN MYLENIA PLAN BUDETU BY ZAKADANY E TO BILANS OTWARCIA
				if( sEncja=="PBD" ) queND->ParamByName("OKRES")->AsInteger = 0;
				else queND->ParamByName("OKRES")->AsInteger = cmbOkresFK->ItemIndex;
*/
				queND->Open();
				queND->Last();
				pgbFK->Max = queND->RecordCount;
				pgbFK->Position = 0;
				queND->First();
				while( !queND->Eof )
				{
					bool bKontoParagraf = false;
					UnicodeString sKonto = queND->FieldByName("KONTO")->AsString;
					if( 	this->bSprawdzKonto( sKonto, edtGenWyd->Text ) || this->bSprawdzKonto( sKonto, edtGenDoch->Text ) ||
							this->bSprawdzKonto( sKonto, edtGenPlan->Text ) || this->bSprawdzKonto( sKonto, edtGenZan->Text ) ) bKontoParagraf = true;
					if( bKontoParagraf && (sKonto.Length()>3))
					{
						// TWORZENIE LINII WSPOLNA DO POZYCJI NR 12
						UnicodeString sLinia = "";
						UnicodeString sRok = edtRok->Text;
						// NAZWA KONTA
						sLinia = sLinia+ "\""+sKonto+"\"|";		// 1->    NUMER KONTA(100)
						UnicodeString sKontoNazwa = queND->FieldByName("NAZWA")->AsString;
						if( sKontoNazwa.Length()==0 ) sKontoNazwa = "NULL";
						sLinia = sLinia+ "\""+objWyk->sSprawdzString( sKontoNazwa )+"\"|";		// 2->		NAZWA KONTA(255)
						// ROZPOZNAJEMY ODPOWIEDNIO NUMER , DZIAL, PARAGRAF, PAR KOSZT i PAR ANAL
						UnicodeString sN="NULL",sD="NULL",sP="NULL",sPK="NULL",sPA="NULL";
						this->vRozpoznajParagraf( sKonto, sN, sD, sP, sPK, sPA );
						if( (sD.Length()==5) && (sD!="NULL") )
						{
							sLinia = sLinia +"\""+ sD.SubString(1,2)+"\"|";		// 3->	 	CZESC BUDZETU(2)
							sLinia = sLinia +"\""+sD.SubString(3,3)+"\"|";		// 4->	 	DZIAL BUDZETU(3)
						}
						else
						{
							sLinia = sLinia + "NULL|";		// 3->	 	CZESC BUDZETU(2)
							sLinia = sLinia + "NULL|";		// 4->	 	DZIAL BUDZETU(3)
						}
						if( sD!="NULL" ) sD = "\""+sD+"\"";
						sLinia = sLinia + sD+"|";		// 5-> 	ROZDZIAL BUDZETU(5)
						if( sP!="NULL" ) sP = "\""+sP+"\"";
						sLinia = sLinia + sP+"|";		// 6->		NUMER PARAGRAFU(4)
						if( sPK!="NULL" ) sPK = "\""+sPK+"\"";
						sLinia = sLinia + sPK+"|";		// 7->		ANALITYKA PARAGRAFU(2)
						if( sPA!="NULL" ) sPA = "\""+sPA+"\"";
						sLinia = sLinia + sPA+"|";		// 8->		ZRODLO FINANSOWANIA(255)
						// ZLICZANIE OBROTOW
						double dObrotyWN = queND->FieldByName("WN")->AsVariant;
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dObrotyWN ),',','.')+"|";		// 9->		OBROTY WN
						double dObrotyMA = queND->FieldByName("MA")->AsVariant;
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dObrotyMA ),',','.')+"|";		// 10->		OBROTY MA
						double dNarastWN = queND->FieldByName("NARAST_WN")->AsVariant;
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dNarastWN ),',','.')+"|";		// 11->		OBROTY WN
						double dNarastMA = queND->FieldByName("NARAST_MA")->AsVariant;
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dNarastMA ),',','.')+"|";		// 12->		OBROTY MA
						if( sEncja=="PBD")
						{
							sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",(dNarastWN - dNarastMA)),',','.') +"|";	// 13->		KWOTA PLANU BUDETU
							sLinia = sLinia + sRok;	// 14->		ROK BUDETOWY
						}
						if( sEncja=="STK")
						{
							sLinia = sLinia + objWyk->sZamienZnak	( FormatFloat("##########0.00",(dNarastWN - dNarastMA)),',','.') +"|";	// 13->		SALDO KONTA
							sLinia = sLinia + sRok+"|";	// 14->		ROK BUDETOWY
							sLinia = sLinia + (UnicodeString)(iOkres);	// 15>		OKRES ROZLICZENIOWY
						}
						// ZAPIS DO PLIKU i PRZEJSCIE NA NASTEPNY REKORD
						sLinia = sLinia+"\n";
						fputs(sLinia.t_str(), fCSV);
					}
					queND->Next();
					pgbFK->Position = queND->RecNo;
				}

			}
			else	// EKSPORTOWANIE Z SYSTEMU DOS
			{
				//tblKPK->TableName = edtFK->Text+"\\kso.dbf";
				UnicodeString s = "DEL "+sKatalog+"\\_QSQL*.dbf";
				system( s.t_str() );
				// OTWARCIE ZBIORU OBROTW
				tblKSO->SQL->Text = "SELECT * FROM '"+edtFK->Text+"\\kso.dbf' ORDER BY SYM_KONTA";
				tblKSO->Open();
				// OTWARCIE ZBIORU PLANU KONT
				tblKPK->SQL->Text = "SELECT * FROM '"+edtFK->Text+"\\kpk.dbf' ORDER BY SYM_KONTA";
				tblKPK->Open();
				tblKPK->Last();
				pgbFK->Max = tblKPK->RecordCount;
				pgbFK->Position = 0;
				tblKPK->First();
				while( !tblKPK->Eof )
				{
					double dObrotyWN,dObrotyMA,dNarastWN,dNarastMA;
					bool bKontoParagraf = false;
					bool bKontoObroty = false;
					UnicodeString sKonto = objWyk->sKonwersja( tblKPK->FieldByName("SYM_KONTA")->AsString, iStandartFK);
					if( 	this->bSprawdzKonto( sKonto, edtGenWyd->Text ) || this->bSprawdzKonto( sKonto, edtGenDoch->Text ) ||
							this->bSprawdzKonto( sKonto, edtGenPlan->Text ) || this->bSprawdzKonto( sKonto, edtGenZan->Text ) ) bKontoParagraf = true;
					if( bKontoParagraf && (sKonto.Length()>3) )
					{
						// TWORZENIE LINII WSPOLNA DO POZYCJI NR 12
						UnicodeString sLinia = "";
						UnicodeString sRok = edtRok->Text;
						// NAZWA KONTA
						sLinia = sLinia+ "\""+objWyk->sSprawdzString( objWyk->sKonwersja( tblKPK->FieldByName("SYM_KONTA")->AsString, iStandartFK) )+"\"|";		// 1->    NUMER KONTA(100)
						UnicodeString sKontoNazwa = objWyk->sKonwersja( tblKPK->FieldByName("NAZW_KONTA")->AsString, iStandartFK);
						if( sKontoNazwa.Length()==0 ) sKontoNazwa = "NULL";
						sLinia = sLinia+ "\""+objWyk->sSprawdzString( sKontoNazwa )+"\"|";		// 2->		NAZWA KONTA(255)
						// ROZPOZNAJEMY ODPOWIEDNIO NUMER , DZIAL, PARAGRAF, PAR KOSZT i PAR ANAL
						UnicodeString sN="NULL",sD="NULL",sP="NULL",sPK="NULL",sPA="NULL";
						this->vRozpoznajParagraf( sKonto, sN, sD, sP, sPK, sPA );
						if( (sD.Length()==5) && (sD!="NULL") )
						{
							sLinia = sLinia +"\""+ sD.SubString(1,2)+"\"|";		// 3->	 	CZESC BUDZETU(2)
							sLinia = sLinia +"\""+ sD.SubString(3,3)+"\"|";		// 4->	 	DZIAL BUDZETU(3)
						}
						else
						{
							sLinia = sLinia + "NULL|";		// 3->	 	CZESC BUDZETU(2)
							sLinia = sLinia + "NULL|";		// 4->	 	DZIAL BUDZETU(3)
						}
						if( sD!="NULL" ) sD = "\""+sD+"\"";
						sLinia = sLinia + sD+"|";		// 5-> 	ROZDZIAL BUDZETU(5)
						if( sP!="NULL" ) sP = "\""+sP+"\"";
						sLinia = sLinia + sP+"|";		// 6->		NUMER PARAGRAFU(4)
						if( sPK!="NULL" ) sPK = "\""+sPK+"\"";
						sLinia = sLinia + sPK+"|";		// 7->		ANALITYKA PARAGRAFU(2)
						if( sPA!="NULL" ) sPA = "\""+sPA+"\"";
						sLinia = sLinia + sPA+"|";		// 8->		ZRODLO FINANSOWANIA(255)
						// ZLICZANIE OBROTOW
						TLocateOptions Opts;
						Opts.Clear();
						Opts << loPartialKey;
						tblKSO->First();
						if( tblKSO->Locate("SYM_KONTA",sKonto,Opts ) )
						{
							bKontoObroty = true;
							dObrotyWN=0, dObrotyMA=0, dNarastWN=0, dNarastMA=0;
							while( (tblKSO->FieldByName("SYM_KONTA")->AsString.Pos( sKonto )==1) && (!tblKSO->Eof) )
							{
								dObrotyWN += this->dPobierzObroty( tblKSO,1, "WN",iOkres );
								dObrotyMA += this->dPobierzObroty( tblKSO,1, "MA",iOkres );
								dNarastWN += this->dPobierzObroty( tblKSO,2, "WN",iOkres );
								dNarastMA += this->dPobierzObroty( tblKSO,2, "MA",iOkres );
								tblKSO->Next();
							}
						}
						// PODSTAWIAMY
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dObrotyWN ),',','.')+"|";		// 9->		OBROTY WN
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dObrotyMA ),',','.')+"|";		// 10->		OBROTY MA
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dNarastWN ),',','.')+"|";		// 11->		OBROTY WN
						sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",dNarastMA ),',','.')+"|";		// 12->		OBROTY MA
						if( sEncja=="PBD")
						{
							sLinia = sLinia + objWyk->sZamienZnak( FormatFloat("##########0.00",(dNarastWN - dNarastMA)),',','.') +"|";	// 13->		KWOTA PLANU BUDETU
							sLinia = sLinia + sRok;	// 14->		ROK BUDETOWY
						}
						if( sEncja=="STK")
						{
							sLinia = sLinia + objWyk->sZamienZnak	( FormatFloat("##########0.00",(dNarastWN - dNarastMA)),',','.') +"|";	// 13->		SALDO KONTA
							sLinia = sLinia + sRok+"|";	// 14->		ROK BUDETOWY
							sLinia = sLinia + (UnicodeString)(iOkres);	// 15>		OKRES ROZLICZENIOWY
						}
						// ZAPIS DO PLIKU i PRZEJSCIE NA NASTEPNY REKORD
						sLinia = sLinia+"\n";
						//if( (dObrotyWN!=0) || (dObrotyMA!=0) || (dNarastWN!=0) || (dNarastMA!=0) ) fputs(sLinia.t_str(), fCSV);
						if( bKontoObroty) fputs(sLinia.t_str(), fCSV);
					}
					pgbFK->Position++;
					tblKPK->Next();
				}
			}
			// ZAMKNIECIE PLIKU
			fclose(fCSV);
		}
		// POBRANIE DANYCH
	}
	catch(Exception &E)
	{
		ShowMessage( "PRZEGRYWANIE BAD"+E.Message );
	}
	delete tblKSO;
	delete tblKPK;
	return iRekord;
}
//---------------------------------------------------------------------
double TfrmSPD::dPobierzObroty(TDataSet *tbl,int iTyp,UnicodeString sStrona,int iOkres)
{
	// iTyp 0 - bilans otwarcia , 1 - obroty bez bilansu , 2 - obroty z bilansem
	double dKwota = 0;
	if( (iTyp==0 || iTyp==2) && ( !tbl->FieldByName("BO_"+sStrona)->IsNull ) )
	{
		dKwota = tbl->FieldByName("BO_"+sStrona)->AsVariant;
	}
	if( iTyp==1 || iTyp==2 )
	{
		for( int i=1;i<=iOkres;i++ )
		{
			UnicodeString sMies =(UnicodeString)i;
			if( i<10 ) sMies = "0"+sMies;
			if( !tbl->FieldByName(sStrona+sMies)->IsNull ) dKwota = dKwota +tbl->FieldByName(sStrona+sMies)->AsVariant;
		}
	}
	return dKwota;
}
//---------------------------------------------------------------------
bool TfrmSPD::bWyslijPlik(UnicodeString sSciezka,UnicodeString sPlik)
{
	bool bWynik = true;
	TMemoryStream *str = new TMemoryStream();
	try
	{
		if( objFTP->Connected() )
		{
			str->LoadFromFile( sSciezka );
			objFTP->Put( str, sPlik, true );
		}
	}
	catch( Exception &e)
	{
		bWynik = false;
	}
	delete str;
	return bWynik;
}
//---------------------------------------------------------------------
bool TfrmSPD::bPolaczFTP(TIdFTP *ftp)
{
	bool bWynik = false;
	bool bAutoBlad = false;
	try
	{
		UnicodeString sFTP = edtFTP->Text;
		UnicodeString sUser = edtUzytkownik->Text;
		UnicodeString sHaslo = edtHaslo1->Text;
		if( (sFTP.Length() > 0) && (sUser.Length() > 0) && (sHaslo.Length() > 0) )
		{
			ftp->ExternalIP = sFTP;
			ftp->Host = sFTP;
			ftp->Username = sUser;
			ftp->Password = sHaslo;
			try
			{
				ftp->Connect();
			}
			catch(Exception &EE )
			{
         	bAutoBlad = true;
			}
			bWynik = ftp->Connected();
		}
		else bAutoBlad = true;
   	// EWENTUALNE WYWOANIE FORMATKI
		if( bAutoBlad )
		{
			if( !frmFTP ) frmFTP = new TfrmFTP( this, ftp, sFTP, sUser, sHaslo );
			if( frmFTP->ShowModal()==6 )
			{
				bWynik = ftp->Connected();
				bWynik = true;
			}
			delete frmFTP;
			frmFTP = NULL;
		}
	}
	catch(Exception &e)
	{

	}
	return bWynik;
}
//---------------------------------------------------------------------
void TfrmSPD::vUstawZapisFTP(bool bZaznaczony)
{
	this->bFTP = bZaznaczony;
	bool bEdycja = true;
	TColor clKolor = clWhite;
	if( bZaznaczony==false )
	{
		bEdycja = false;
		clKolor = clInfoBk;
	}
	edtUzytkownik->Color = clKolor;
	edtHaslo1->Color = clKolor;
	edtHaslo2->Color = clKolor;
	edtFTP->Color = clKolor;
	edtSciezkaFTP->Color = clKolor;
	edtPort->Color = clKolor;
	// ENABLED
	edtUzytkownik->Enabled = bEdycja;;
	edtHaslo1->Enabled = bEdycja;;
	edtHaslo2->Enabled = bEdycja;;
	edtFTP->Enabled = bEdycja;;
	edtSciezkaFTP->Enabled = bEdycja;;
	edtPort->Enabled = bEdycja;
}
//---------------------------------------------------------------------
void TfrmSPD::vRozpoznajParagraf(UnicodeString sKonto,UnicodeString &sNumer,UnicodeString &sDzial,UnicodeString &sParag,
											UnicodeString &sParagKoszt,UnicodeString &sParagAnal)
{
	if( sKonto.Length() > 3 )
	{
		if( sKonto[4]!='-' ) sKonto = sKonto.SubString(1,3)+"-"+sKonto.SubString(4,sKonto.Length());
		TStringList *lstTemp = new TStringList();
		lstTemp->Clear();
		try
		{
			AnsiString sTok="";
			// ROZBIJAMY CHCIANY CIAG NA SKLADNIKI
			for( int i=5;i<=sKonto.Length();i++ )
			{
				if( sKonto[i]!='-' )
				{
					sTok = sTok + (AnsiString)sKonto[i];
					if( i==sKonto.Length() )
					{
						lstTemp->Add( sTok);
						sTok = "";
					}
				}
				else
				{
					lstTemp->Add( sTok );
					lstTemp->Add( "-" );
					sTok = "";
				}
			}
			// USTALAMY CZY JEST NUMER ITP ....
			bool bNumer = true;
			bool bAnal = false;
			for( int i=0;i<lstTemp->Count;i++ )
			{
				sTok = lstTemp->Strings[i];
				int n = sTok.Length();
				bool bUzyty = false;
				if( sTok!="-" )
				{
					// DZIAL
					if( (sDzial=="NULL" ) &&  (n==5)  )
					{
						sDzial = sTok;
						bUzyty = true;
						bNumer = false;
					}
					// PARAGRAF
					if( (sParag=="NULL" ) && ( (n==4) || (n==3) ) )
					{
						sParag = sTok;
						bUzyty = true;
						bNumer = false;
					}
					// POZYCJA PARAGRAFU
					if( (sParagKoszt=="NULL") && (sParag.Length()>0) && ((n==2) || (n==1)) && (sParag!="NULL") )
					{
						sParagKoszt = sTok;
						bUzyty = true;
						bNumer = false;
						bAnal = true;
					}
				}
				// JEZELI NIE UZYLISMY WCZESNIEJ
				if( !bUzyty ) // DOKLEJAMY JAKO NUMER LUB JAKO ANALITYKE PARAGRAFU
				{
					// DODATKOWA ANALITYKA GDY  JEST PARAGRAF KOSZT W PRZECIWNYM WYPADKU TO NUMER
					if( bAnal && (sParagKoszt!="NULL") )
					{
						if( sParagAnal=="NULL" ) sParagAnal = sTok;
						else sParagAnal = sParagAnal + sTok;
					}
					if( bNumer )
					{
						if( sNumer=="NULL") sNumer = sTok;
						else sNumer = sNumer + sTok ;
					}
				}
			}
			// PRZESZLIMY JUZ WSZYSTKO i TERAZ SPRAWDZAMY sNumer i sAnalityka
			if( sNumer.Length()>0 )
			{
				if( sNumer[1]=='-' ) sNumer = sNumer.SubString( 2, sNumer.Length()-1 );
				if( sNumer[ sNumer.Length() ]=='-' ) sNumer = sNumer.SubString( 1, sNumer.Length()-1 );
			}
			if( sParagAnal.Length()>0 )
			{
				if( sParagAnal[1]=='-' ) sParagAnal = sParagAnal.SubString( 2, sParagAnal.Length()-1 );
				if( sParagAnal[ sParagAnal.Length() ] =='-' ) sParagAnal = sParagAnal.SubString( 1, sParagAnal.Length()-1 );
			}
		}
		catch(Exception &e)
		{
		}
		// ZWROT WARTOSCI
		delete lstTemp;
	}
}
//---------------------------------------------------------------------
// GENEROWANIE JEDNORAZOWE
//---------------------------------------------------------------------
int  TfrmSPD::iFKGenKont(	UnicodeString sWyd,
									UnicodeString sDoch,
									UnicodeString sPlan,
									UnicodeString sZan,
									UnicodeString sOper,
									UnicodeString sCzesc)
{
	//	iTryb :: 0 - mapowanie kont, 1 mapowanie poz. budetowych
	int iRekord = 0;
	UnicodeString sPlik = this->sKatalog +"\\MapKont.csv";
	UnicodeString sPlikAll = this->sKatalog +"\\MapKontAll.csv";
	TQuery *quePK = new TQuery(this);
	try
	{
		// PRZYGOTOWUJEMY PLIK
		if( FileExists( sPlik ) ) DeleteFile( sPlik );
		if( FileExists( sPlikAll ) ) DeleteFile( sPlikAll );
		FILE *f = fopen( sPlik.t_str(), "a+");
		FILE *fAll = fopen( sPlikAll.t_str(), "a+");
		// PRZECHODZIMY PRZEZ PLANKONT
		pgbGen->Position = 0;
//		quePK->TableName = this->sZnajdzParametr( "sFK_KATALOG" )+"\\kpk.dbf";
		UnicodeString sSciezka = edtFK->Text+"\\kpk.dbf";
		quePK->SQL->Text ="SELECT * FROM \""+sSciezka+"\" ORDER BY SYM_KONTA";
		quePK->Open();
		quePK->Last();
		pgbGen->Max = quePK->RecordCount;
		quePK->First();
		while( !quePK->Eof )
		{
			bool bKontoParagraf = false;
			UnicodeString sLinia="";
			UnicodeString sKonto = quePK->FieldByName("SYM_KONTA")->AsString;
			UnicodeString sWartosc = "0";
			// SPRAWDZAAMY CZY MOZEMY DOPISA DO PLIKU WYBRANEGO
			if( 	this->bSprawdzKonto( sKonto, sWyd ) || this->bSprawdzKonto( sKonto, sDoch ) ||
					this->bSprawdzKonto( sKonto, sPlan ) || this->bSprawdzKonto( sKonto, sZan ) ) bKontoParagraf = true;
			// POBIERAMY PARAGRAFY
			UnicodeString sRozdzial = " ";
			UnicodeString sParagraf = " ";
			UnicodeString sAnalPar = " ";
			if( bKontoParagraf )
			{
				// PRZYPADEK 1300-75410-4020-10
				UnicodeString sTemp;
				int n = sKonto.Length();
				if( (n>=18) || (n==17) || (n==15) || (n==9 ) || (n==12) ) sTemp = sKonto.SubString( 6, sKonto.Length() );
				if( (n==16) || (n==13) || (n==7) || (n==10) ) sTemp = sKonto.SubString( 4, sKonto.Length() );
				switch( sTemp.Length() )
				{
					case 13 :   //D-P-K 5-4-2
						sRozdzial = sTemp.SubString(1,5);
						sParagraf = sTemp.SubString(7,4);
						sAnalPar = sTemp.SubString(12,2);
					break;                                     ;
					case 12 :   //D-P-K 5-3-2
						if( sTemp[10]=='-' )
						{
							sRozdzial = sTemp.SubString(1,5);
							sParagraf = sTemp.SubString(7,3);
							sAnalPar = sTemp.SubString(11,2);
						}
						if( sTemp[11]=='-' )
						{
							sRozdzial = sTemp.SubString(1,5);
							sParagraf = sTemp.SubString(7,4);
							sAnalPar = sTemp.SubString(12,1);
						}
					break;
					case 10 :    //D-P 5-4
						sRozdzial = sTemp.SubString(1,5);
						sParagraf = sTemp.SubString(7,4);
					break;
					case 9 :    //D-P 5-3 LUB 4-4
						if( sTemp[6]=='-' )
						{
							sRozdzial = sTemp.SubString(1,5);
							sParagraf = sTemp.SubString(7,3);
						}
						if( sTemp[5]=='-' )
						{
							sRozdzial = sTemp.SubString(1,4);
							sParagraf = sTemp.SubString(6,4);
						}
					break;
					case 7 :    //P-K 4-2
						sParagraf = sTemp.SubString(1,4);
						sAnalPar = sTemp.SubString(6,2);
					break;
					case 6 : 	// NUM-P 1-4
						if( sTemp[2]=='-')
						{
							sParagraf = sTemp.SubString(3,4);
						}
					break;
					case 5 :
               	sRozdzial = sTemp;
					break;
				}
				if( sTemp.Length()>13 )
				{
					//D-P-K 5-4-2 - i Reszta si nie licz
					sRozdzial = sTemp.SubString(1,5);
					sParagraf = sTemp.SubString(7,4);
					sAnalPar = sTemp.SubString(12,2);
				}
			}
			// Numer konta
			sLinia = sLinia + sKonto+";";
			// Nazwa konta
			sLinia = sLinia + quePK->FieldByName("NAZW_KONTA")->AsString.UpperCase()+";";
			// Numer czci
			sLinia = sLinia + sCzesc + ";";
			// Numer dziau
			sLinia = sLinia + sRozdzial.SubString(1,3) + ";";
			// Numer rozdziau
			sLinia = sLinia + sRozdzial + ";";
			// Numer paragrafu
			sLinia = sLinia + sParagraf + ";";
			// Numer anal. paragrafu
			sLinia = sLinia + sAnalPar + ";";
			// Wydatki/Dochody
			if( this->bSprawdzKonto( sKonto , sDoch ) ) sWartosc = "D";
			else sWartosc = "W";
			sLinia = sLinia + sWartosc + ";";
			// Nazwa rda finansowania
			sWartosc = " ";
			sLinia = sLinia + sWartosc + ";";
			// Nazwa komrki organizacyjnej
			sWartosc = " ";
			sLinia = sLinia + sWartosc + ";";
			// Nazwa jednostki organizacyjnej
			sWartosc = " ";
			sLinia = sLinia + sWartosc + ";";
			// Znacznik szczegowoci paragrafu
			sWartosc = "0";
			if( (sParagraf.Length() > 0 ) && (sParagraf!=" " ) && ( sAnalPar==" ") )
			{
				if( this->bSprawdzZnacznik( bKontoParagraf,sKonto )==false ) sWartosc = "1";
			}
			sLinia = sLinia + sWartosc + ";";
			// Znacznik szczegowoci analityki paragrafu
			sWartosc = "0";

			if( (sAnalPar.Length()>0) && (sAnalPar!=" ") )
			{
				if( this->bSprawdzZnacznik( bKontoParagraf, sKonto )==false ) sWartosc = "1";
			}
			sLinia = sLinia + sWartosc + ";";
			// Znacznik szczegowoci rda fin.
			sWartosc = "0";
			sLinia = sLinia + sWartosc + ";";
			// Znacznik szczegowoci komrki org.
			sWartosc = "0";
			sLinia = sLinia + sWartosc + ";";
			// Mnonik salda konta
			sWartosc = "0";
			if( this->bSprawdzKonto( sKonto , sPlan ) || this->bSprawdzKonto( sKonto , sZan ) ) sWartosc = "1";
			sLinia = sLinia + sWartosc + ";";
			// Mnonik salda strony winien
			sWartosc = "0";
			if( this->bSprawdzKonto( sKonto , sDoch ) ) sWartosc = "1";
			sLinia = sLinia + sWartosc + ";";
			// Mnonik salda strony ma
			sWartosc = "0";
			if( this->bSprawdzKonto( sKonto , sWyd ) ) sWartosc = "1";
			sLinia = sLinia + sWartosc + ";";
			// Mnonik obrotw strony winien
			sWartosc = "0";
			sLinia = sLinia + sWartosc+ ";";
			// Mnonik obrotw strony ma
			sWartosc = "0";
			sLinia = sLinia + sWartosc + ";";
			// Data obowizywania od (RRRR-MM-DD)
			sLinia = sLinia + "2010-09-01;";
			// Data obowizywania do (RRRR-MM-DD)
			sLinia = sLinia + "2100-12-31;";
			// Wprowadzajcy
			sLinia = sLinia +  sOper + ";\n";
			sLinia = objWyk->sKonwersja( sLinia , this->iStandartFK );
			if( f && bKontoParagraf) fputs( sLinia.t_str(), f );
			if( fAll ) fputs( sLinia.t_str(), fAll );
			// PRZEJSCIE NA NASTEPNY REKORD
			quePK->Next();
			iRekord++;
			pgbGen->Position = quePK->RecNo;
		}
		fclose( f );
		fclose( fAll );
	}
	catch(Exception &e)
	{
		ShowMessage("Error  in iFKGenKont(...)\n\n"+e.Message);
		iRekord = -1;
	}
	delete quePK;
	if( iRekord > 0 )
	{
		UnicodeString sCMD = "NOTEPAD "+sPlik;
		system( sCMD.t_str() );
	}
	return iRekord;
}
//---------------------------------------------------------------------
bool TfrmSPD::bSprawdzKonto(UnicodeString sKonto,UnicodeString sSchemat)
{
	bool bOk = false;
	TStringList *lstTemp = new TStringList();
	try
	{
		UnicodeString sItem = "";
		for( int i=1;i<=sSchemat.Length();i++ )
		{
			char c = sSchemat[i];
			if( c==',' )
			{
         	lstTemp->Add( sItem );
				sItem ="";
			}
			else sItem = sItem + (UnicodeString)c;
		}
		// Sprawdzamy czy istnieje takie sKonto w licie schematw
		for( int i=0;i<lstTemp->Count;i++ )
		{
			if( sKonto.Pos( lstTemp->Strings[i] )==1 )
			{
         	bOk = true;
				break;
			}
		}
	}
	catch( Exception &e)
	{
	}
	delete lstTemp;
	return bOk;
}
//---------------------------------------------------------------------
bool TfrmSPD::bSprawdzZnacznik(bool bKontoPar,UnicodeString sKonto)
{
	bool bIstnieje = false;
	int iLicznik = 0;
	if( bKontoPar && (sKonto.Length()>3) )
	{
		TTable *tbl = new TTable(this);
		try
		{

			tbl->TableName = edtFK->Text+"\\kpk.dbf";
			tbl->Open();
			TLocateOptions Opts;
			Opts.Clear();
			Opts << loCaseInsensitive;
			if( tbl->Locate("SYM_KONTA",sKonto,Opts ) )
			{
				bool bToSamo = true;
				while( bToSamo  )
				{
					if(tbl->FieldByName("SYM_KONTA")->AsString.Pos(sKonto)==1 ) iLicznik++;
					else bToSamo = false;
					if( tbl->Eof) bToSamo = false;
					tbl->Next();
				}
			}
		}
		catch( Exception &e)
		{
      	ShowMessage( e.Message );
		}
		delete tbl;
	 }
	if( iLicznik > 1 ) bIstnieje = true;
	return bIstnieje;
}

//---------------------------------------------------------------------
// OBSLUGA ZDARZEN
//---------------------------------------------------------------------
//---------------------------------------------------------------------
void __fastcall TfrmSPD::HelpAbout1Execute(TObject *Sender)
{
  frmAboutBox->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::treeSPDChange(TObject *Sender, TTreeNode *Node)
{
	if( this->Visible )
	{
		pgSPD->ActivePageIndex = treeSPD->Selected->SelectedIndex;
		bool bPokazZatwierdz = false;
		if( 	(pgSPD->ActivePage==tbsFK) ||
				(pgSPD->ActivePage==tbsPlace) ||
				(pgSPD->ActivePage==tbsUstawienia) ) bPokazZatwierdz = true;
		pnlZatwierdz->Visible = bPokazZatwierdz;
	}
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::tyiSPDDblClick(TObject *Sender)
{
	this->Visible = !this->Visible ;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::actZasobnikExecute(TObject *Sender)
{
	this->Visible = false;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::FormClose(TObject *Sender, TCloseAction &Action)
{
	this->Visible = false;
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::actZakonczExecute(TObject *Sender)
{
	Application->Terminate();
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::actZatwierdzExecute(TObject *Sender)
{
	if( pnlZatwierdz->Visible && btnZatwierdz->Enabled )
	{
		if( this->bSprawdzFormatke() )
		{
			this->vZapiszUstawienia( true );
			btnZatwierdz->Enabled = false;
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::actAnulujExecute(TObject *Sender)
{
	if( pnlZatwierdz->Visible ) ShowMessage("ANULUJ");
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::FormDestroy(TObject *Sender)
{
	this->vDeInicjacja();
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::actUstawienieChangeExecute(TObject *Sender)
{
	if( this->Visible ) btnZatwierdz->Enabled =  true;
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::pgSPDChange(TObject *Sender)
{
	if( this->Visible )
	{
		if( pgSPD->ActivePage == tbsFK )
		{
			cmbOkresFK->SetFocus();
			lblFK->Caption = "";
			pgbFK->Position = 0;
		}
		if( pgSPD->ActivePage == tbsPlace ) edtPlace->SetFocus();
		if( pgSPD->ActivePage == tbsUstawienia ) edtUzytkownik->SetFocus();
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::actZasilFKExecute(TObject *Sender)
{
	if( this->Visible )
	{
		bool bOK = true;
		if( pnlZatwierdz->Enabled )
		{
			bOK = this->bSprawdzFormatke();
			this->vZapiszUstawienia( true );
		}
		if( bOK )
		{
			UnicodeString sBlad="";
			if( this->cmbOkresFK->ItemIndex > 0 )
			{
				if( this->chbPBD->Checked || this->chbSTK->Checked ) this->vWyslijFK(cmbOkresFK->ItemIndex,dtpFK->Date, chbPBD->Checked, chbSTK->Checked );
				else
				{
					sBlad = "Wybierz jedn z opcji plan budetu lub stan kont ";
					chbSTK->SetFocus();
				}
			}
			else
			{
				sBlad = "Wybierz okres za jaki wygenerowa dane.";
				cmbOkresFK->SetFocus();
			}
			if( sBlad.Length() > 0 ) MessageBox( Application->Handle, sBlad.t_str(),"Bd!", MB_OK | MB_ICONHAND | MB_APPLMODAL );
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::actKatalogExecute(TObject *Sender)
{
	if( this->Visible )
	{
		if( this->ActiveControl->ClassNameIs("TButton") )
		{
//			TButton *btn = static_cast<TButton*>(this->ActiveControl);
			TEdit *edt = NULL;
			if( static_cast<TButton*>(this->ActiveControl)->Name=="btnFK" ) edt = edtFK;
			if( static_cast<TButton*>(this->ActiveControl)->Name=="btnArchFK" ) edt = edtArchFK;
			if( static_cast<TButton*>(this->ActiveControl)->Name=="btnPlace" ) edt = edtPlace;
			if( static_cast<TButton*>(this->ActiveControl)->Name=="btnArchPlace" ) edt = edtPlaceArch;
			if( edt )
			{
				UnicodeString sDir = this->sKatalog;
				if( edt->Text.Length()>0 ) sDir = edt->Text;
				if (SelectDirectory(sDir, TSelectDirOpts() << sdAllowCreate << sdPerformCreate << sdPrompt,-1)) edt->Text = sDir;
			}
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::chbFTPClick(TObject *Sender)
{
	if( pnlZatwierdz->Visible && this->Visible )
	{
		btnZatwierdz->Enabled =  true;
		vUstawZapisFTP( chbFTP->Checked );
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::actFKGenKontExecute(TObject *Sender)
{
	if( this->Visible )
	{
		bool bOk = false;
		if( edtGenOper->Text.Length() > 0 )
		{
			bOk = true;
			if( pnlZatwierdz->Enabled )
			{
				bOk = this->bSprawdzFormatke();
				this->vZapiszUstawienia( true );
			}
		}
      // MONA GENEROWA MAPOWANIE PLANU KONT
		if( bOk )
		{
			this->iFKGenKont(	edtGenWyd->Text,edtGenDoch->Text,
									edtGenPlan->Text,edtGenZan->Text,
									edtGenOper->Text,edtGenCzesc->Text);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TfrmSPD::actTempExecute(TObject *Sender)
{
/*
	UnicodeString sKonto = "1300-57409-4020-01-01";
	UnicodeString sN="NULL",sD="NULL",sP="NULL",sPK="NULL",sPA="NULL";
	this->vRozpoznajParagraf( sKonto, sN, sD, sP, sPK, sPA );
	ShowMessage( sKonto+"\nNumer : "+sN+"\nDzia :" +sD+"\nParagraf : "+sP+"\nKoszt : "+sPK+"\nAnal : "+sPA+"\n");
*/
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::dbBazaBeforeConnect(TObject *Sender)
{
	try
	{
		if( edtFK->Text.Length() > 0 ) dbBaza->DatabaseName = edtFK->Text;
	}
	catch( Exception &e)
	{
	}
}
//---------------------------------------------------------------------------

void __fastcall TfrmSPD::Button1Click(TObject *Sender)
{
/*
	UnicodeString sDoPodpisu =  this->sKatalog+"\\"+Edit1->Text+".zip";
	UnicodeString sMD5 = MD5File( sDoPodpisu.t_str() );
	UnicodeString sPlik = this->sKatalog + "\\"+Edit1->Text+".md5";
	FILE *fMD5 = fopen( sPlik.t_str(),"w");
	if( fMD5 )
	{
		fputs( sMD5.t_str(), fMD5 );
		fclose( fMD5 );
		sPlik = this->sKatalog + "\\"+Edit1->Text+".sem";
		FILE *fSEM = fopen( sPlik.t_str(),"w");
		if( fSEM ) fclose(fSEM);
		ShowMessage("WSZYSTKO GOTOWE !!");
	}
*/
}
//---------------------------------------------------------------------------

